<template lang="pug">
  div
    v-layout(row wrap justify-space-around)
      v-flex(xs12 lg3 sm6 md6 d-flex)
        v-text-field(
          v-model="login"
          label="Логин"
          :error-messages="loginErrors"
          required
          outline
          @input="$v.login.$touch()"
          @blur="$v.login.$touch()"
        )

    v-layout(row wrap justify-space-around)
      v-flex(xs12 lg3 sm6 md6 d-flex)
        v-text-field(
          v-model="password"
          type="password"
          label="Пароль"
          :error-messages="passwordErrors"
          required
          outline
          @input="$v.password.$touch()"
          @blur="$v.password.$touch()"
        )

    .b-login__row.b-login__row--center
      button-field(
        :clickAction="submit"
      )
        | Вход
</template>

<script>
import { required, email } from 'vuelidate/lib/validators';
import ButtonField from '../button/index.vue';

export default {
  name: 'Login',
  components: {
    ButtonField,
  },
  data() {
    return {
      isSetedLogin: false,
      isSetedPassword: false,
    };
  },
  validations: {
    login: { required, email },
    password: { required },
  },
  computed: {
    loginErrors() {
      const errors = [];
      if (!this.$v.login.$dirty) return errors;
      if (!this.$v.login.required) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.login.email) {
        errors.push('Email не валиден.');
      }
      return errors;
    },
    passwordErrors() {
      const errors = [];
      if (!this.$v.password.$dirty) return errors;
      if (!this.$v.password.required) {
        errors.push('Обязательно для заполнения.');
      }
      return errors;
    },
    login: {
      get() {
        return this.$store.getters.getLogin;
      },
      set(value) {
        this.$store.commit('setLogin', value);
      },
    },
    password: {
      get() {
        return this.$store.getters.getPassword;
      },
      set(value) {
        this.$store.commit('setPassword', value);
      },
    },
  },
  methods: {
    async submit() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        await this.$store.dispatch('auth');

        this.$router.push({
          name: 'Report',
        });
      }
    },
  },
};
</script>

<style lang="scss">
@import '@/assets/styles/additional/_variables.scss';
@import '@/blocks/login/login.scss';
</style>
